



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>NodeJS学习：搭建私有NPM</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">NodeJS学习：搭建私有NPM</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 18:32:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>工具</h3>
<ul><li>verdaccio</li>
<li>nrm</li>
<li>pm2</li></ul>
<h3>特点</h3>
<p><code>verdaccio</code> 的特点：</p>
<ul><li>不同步拉取npm库，占据大量硬盘，没有硬盘被撑爆的问题；</li>
<li>安装配置极其简单,不需要数据库；</li>
<li>支持配置上游registry配置，拉取即缓存；</li>
<li>支持forever及pm2守护进程管理；</li>
<li>私有npm package 管理</li>
<li>支持 docker 等应用容器</li></ul>
<p><code>verdaccio</code> 是上一个 <code>sinopia</code> 的交叉分支。</p>
<h3>安装 verdaccio</h3>
<pre class="prettyprint linenums"><code>npm i verdaccio -g<br />
</code></pre>
<p>安装好后，执行 <code>verdaccio</code> 即可以看到本地 <code>NPM</code> 的web管理界面。</p>
<h3>更换 registry</h3>
<p>不推荐</p>
<pre class="prettyprint linenums"><code>npm config set registry http://<br />
</code></pre>
<p>推荐</p>
<pre class="prettyprint linenums"><code>npm i nrm -g

nrm list | nrm ls<br />
nrm add [name] [http://url]<br />
nrm use [name]<br />
nrm del [name]<br />
</code></pre>
<h3>创建NPM账号</h3>
<pre class="prettyprint linenums"><code>npm adduser | npm adduser --registry  http：// localhost：4873 /<br />
username:***<br />
password:***<br />
</code></pre>
<p>其它用户相关命令：</p>
<pre class="prettyprint linenums"><code>npm login  #登陆<br />
npm logout #退出<br />
npm whoami #查看当前用户<br />
</code></pre>
<h3>发布package</h3>
<pre class="prettyprint linenums"><code>npm publish<br />
</code></pre>
<p>升级版本号</p>
<pre class="prettyprint linenums"><code>npm version patch #升级补丁版本号<br />
npm version minor #升级副版本号<br />
npm version major #升级主版本号<br />
</code></pre>
<h3>verdaccio - profile</h3>
<p><code>verdaccio</code> 的配置文件是默认存放在用户目录中的，在window上其路径是：<code>~\Users\Administrator\.config\verdaccio</code></p>
<ul><li>storage     : 存放 npm包的目录。</li>
<li>config.yaml : <code>verdaccio</code> 的配置文件</li>
<li>htpasswd    ： 用于保存注册的用户。</li></ul>
<p><strong>config.yaml说明</strong></p>
<pre class="prettyprint linenums"><code>##设置NPM包的存放目录<br />
storage: ./storage   

# 配置WEB UI界面<br />
web :<br />
    title : '搭建私有NPM'<br />
    #logo : logo.png

## 设置用户验证的文件。<br />
auth:<br />
  htpasswd:<br />
    file: ./htpasswd<br />
    max_users: 1000   #默认为1000，改为-1，禁止注册

# 设置其它的npm注册源(registry)<br />
uplinks:<br />
  npmjs:<br />
    url: https://registry.npmjs.org/

#配置权限管理<br />
packages:<br />
  '@*/*':<br />
    #表示哪一类用户可以对匹配的项目进行安装 【$all 表示所有人都可以执行对应的操作，$authenticated 表示只有通过验证的人可以执行对应操作，$anonymous 表示只有匿名者可以进行对应操作（通常无用）】<br />
    access: $all<br />
     #表示哪一类用户可以对匹配的项目进行发布<br />
    publish: $authenticated

  '*':<br />
    #表示哪一类用户可以对匹配的项目进行安装<br />
    access: $all

    #表示哪一类用户可以对匹配的项目进行发布<br />
    publish: $authenticated

    # 如果一个npm包不存在，它会去询问设置的代理。<br />
    proxy: npmjs

# 日志输出设置<br />
logs:<br />
  - {type: stdout, format: pretty, level: http}<br />
  #- {type: file, path: verdaccio.log, level: info}

#修改监听的端口<br />
#listen: 0.0.0.0:4873  

</code></pre>
<h3>PM2启动 verdaccio</h3>
<pre class="prettyprint linenums"><code>pm2 start verdaccio<br />
</code></pre>
<h3>还需要...</h3>
<ul><li>在服务器上搭建</li>
<li>按需进行用户权限分组？</li>
<li>Nginx代理</li></ul>
<blockquote><p><a href="http://www.verdaccio.org/" rel="external nofollow noreferrer">http://www.verdaccio.org/</a></p></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93dzz83.html">listview下拉刷新和上拉加载更多的多种实现方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwl5rr9.html">Android Studio 导入百度地图jar和so的正确方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8epg2m9.html">Linux就这个范儿 第9章 特种文件系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k11n2j9.html">Python学习（6）循环语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjwx2z9.html">linux 串口阻塞与非阻塞参数设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnlk1z8.html">delete错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd0mjd8.html">JSON介绍与JavaScript解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oz52y9.html">Number of Rectangles in a Grid</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwde1wl8.html">nini</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydnyj2q.html">hibernate性能消耗太狠了。果断减肥引发的连串意外惊喜</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpdp07q.html">用css、html编写一个两列布局的网页，名称为css&period;html ，要求左侧宽度为200px ，右侧自动扩展</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljvx5e9.html">【nodejs】nodejs 的linux安装&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljwyyk9.html">PE文件格式详解&comma;第二讲&comma;NT头文件格式&comma;以及文件头格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mg36m8.html">python8--文件操作 with。。。open语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zrzy59.html">浅谈React</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvk02z8.html">xshell 使用root 连接ubuntu server</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1njrg9.html">在 vue&period;js 中动态绑定 v-model</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m20od6q.html">CF 666E Forensic Examination&mdash;&mdash;广义后缀自动机&plus;线段树合并</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r0m7z8.html">Swap Nodes in Pairs LeetCode题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjkzxjq.html">Mac iTerm2登陆CentOS提示warning&colon; setlocale&colon; LC&lowbar;CTYPE&colon; cannot change locale &lpar;UTF-8&rpar;&colon; No such file or directory</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pwykmd8.html">Spark记录-SparkSQL远程操作MySQL和ORACLE</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdrewv9.html">《高性能Mysql》讲聚簇索引</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gvj0eq.html">codeforces - 432D Prefixes and Suffixes &lpar;next数组&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj05149.html">JavaScript 数字转汉字&plus;element时间选择器快速选择</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rnlr08.html">Spring 学习03</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw3zgz9.html">&lbrack;iOS&rsqb;App上架流程&lbrack;利用Archive进行上传&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyl04gq.html">如何利用 Python 完成验签操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdr4409.html">Servlet3&period;0的注解自定义原生Listener监听器实战</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwyeok8.html">Dubbo服务容错（整合hystrix）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4771j9.html">【Python】JBOSS-JMX-EJB-InvokerServlet批量检测工具</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
